/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 */
package blanco.sed.task;

import java.io.IOException;

import blanco.sed.task.valueobject.BlancoSedProcessInput;

/**
 * バッチ処理クラス [BlancoSedBatchProcess]。
 *
 *
 * バッチ処理の呼び出し例。
 * <code>
 * java -classpath (クラスパス) blanco.sed.task.BlancoSedBatchProcess -help
 * </code>
 */
public class BlancoSedBatchProcess {
    /**
     * 正常終了。
     */
    public static final int END_SUCCESS = 0;

    /**
     * 入力異常終了。内部的にjava.lang.IllegalArgumentExceptionが発生した場合。
     */
    public static final int END_ILLEGAL_ARGUMENT_EXCEPTION = 7;

    /**
     * 入出力例外終了。内部的にjava.io.IOExceptionが発生した場合。
     */
    public static final int END_IO_EXCEPTION = 8;

    /**
     * 異常終了。バッチの処理開始に失敗した場合、および内部的にjava.lang.Errorまたはjava.lang.RuntimeExceptionが発生した場合。
     */
    public static final int END_ERROR = 9;

    /**
     * コマンドラインから実行された際のエントリポイントです。
     *
     * @param args コンソールから引き継がれた引数。
     */
    public static final void main(final String[] args) {
        final BlancoSedBatchProcess batchProcess = new BlancoSedBatchProcess();

        // バッチ処理の引数。
        final BlancoSedProcessInput input = new BlancoSedProcessInput();

        boolean isNeedUsage = false;
        boolean isFieldInputProcessed = false;
        boolean isFieldOutputProcessed = false;

        // コマンドライン引数の解析をおこないます。
        for (int index = 0; index < args.length; index++) {
            String arg = args[index];
            if (arg.startsWith("-verbose=")) {
                input.setVerbose(Boolean.valueOf(arg.substring(9)).booleanValue());
            } else if (arg.startsWith("-input=")) {
                input.setInput(arg.substring(7));
                isFieldInputProcessed = true;
            } else if (arg.startsWith("-output=")) {
                input.setOutput(arg.substring(8));
                isFieldOutputProcessed = true;
            } else if (arg.startsWith("-script=")) {
                input.setScript(arg.substring(8));
            } else if (arg.startsWith("-scriptfile=")) {
                input.setScriptfile(arg.substring(12));
            } else if (arg.startsWith("-encoding=")) {
                input.setEncoding(arg.substring(10));
            } else if (arg.equals("-?") || arg.equals("-help")) {
                usage();
                System.exit(END_SUCCESS);
            } else {
                System.out.println("BlancoSedBatchProcess: 入力パラメータ[" + arg + "]は無視されました。");
                isNeedUsage = true;
            }
        }

        if (isNeedUsage) {
            usage();
        }

        if( isFieldInputProcessed == false) {
            System.out.println("BlancoSedBatchProcess: 処理開始失敗。入力パラメータ[input]の必須フィールド値[input]に値が設定されていません。");
            System.exit(END_ILLEGAL_ARGUMENT_EXCEPTION);
        }
        if( isFieldOutputProcessed == false) {
            System.out.println("BlancoSedBatchProcess: 処理開始失敗。入力パラメータ[input]の必須フィールド値[output]に値が設定されていません。");
            System.exit(END_ILLEGAL_ARGUMENT_EXCEPTION);
        }

        int retCode = batchProcess.execute(input);

        // 終了コードを戻します。
        // ※注意：System.exit()を呼び出している点に注意してください。
        System.exit(retCode);
    }

    /**
     * 具体的なバッチ処理内容を記述するためのメソッドです。
     *
     * このメソッドに実際の処理内容を記述します。
     *
     * @param input バッチ処理の入力パラメータ。
     * @return バッチ処理の終了コード。END_SUCCESS, END_ILLEGAL_ARGUMENT_EXCEPTION, END_IO_EXCEPTION, END_ERROR のいずれかの値を戻します。
     * @throws IOException 入出力例外が発生した場合。
     * @throws IllegalArgumentException 入力値に不正が見つかった場合。
     */
    public int process(final BlancoSedProcessInput input) throws IOException, IllegalArgumentException {
        // 入力パラメータをチェックします。
        validateInput(input);

        // この箇所でコンパイルエラーが発生する場合、BlancoSedProcessインタフェースを実装して blanco.sed.taskパッケージに BlancoSedProcessImplクラスを作成することにより解決できる場合があります。
        final BlancoSedProcess process = new BlancoSedProcessImpl();

        // 処理の本体を実行します。
        final int retCode = process.execute(input);

        return retCode;
    }

    /**
     * クラスをインスタンス化してバッチを実行する際のエントリポイントです。
     *
     * このメソッドは下記の仕様を提供します。
     * <ul>
     * <li>メソッドの入力パラメータの内容チェック。
     * <li>IllegalArgumentException, RuntimeException, Errorなどの例外をcatchして戻り値へと変換。
     * </ul>
     *
     * @param input バッチ処理の入力パラメータ。
     * @return バッチ処理の終了コード。END_SUCCESS, END_ILLEGAL_ARGUMENT_EXCEPTION, END_IO_EXCEPTION, END_ERROR のいずれかの値を戻します。
     * @throws IllegalArgumentException 入力値に不正が見つかった場合。
     */
    public final int execute(final BlancoSedProcessInput input) throws IllegalArgumentException {
        try {
            // バッチ処理の本体を実行します。
            int retCode = process(input);

            return retCode;
        } catch (IllegalArgumentException ex) {
            System.out.println("BlancoSedBatchProcess: 入力例外が発生しました。バッチ処理を中断します。:" + ex.toString());
            // 入力異常終了。
            return END_ILLEGAL_ARGUMENT_EXCEPTION;
        } catch (IOException ex) {
            System.out.println("BlancoSedBatchProcess: 入出力例外が発生しました。バッチ処理を中断します。:" + ex.toString());
            // 入力異常終了。
            return END_IO_EXCEPTION;
        } catch (RuntimeException ex) {
            System.out.println("BlancoSedBatchProcess: ランタイム例外が発生しました。バッチ処理を中断します。:" + ex.toString());
            ex.printStackTrace();
            // 異常終了。
            return END_ERROR;
        } catch (Error er) {
            System.out.println("BlancoSedBatchProcess: ランタイムエラーが発生しました。バッチ処理を中断します。:" + er.toString());
            er.printStackTrace();
            // 異常終了。
            return END_ERROR;
        }
    }

    /**
     * このバッチ処理クラスの使い方の説明を標準出力に示すためのメソッドです。
     */
    public static final void usage() {
        System.out.println("BlancoSedBatchProcess: Usage:");
        System.out.println("  java blanco.sed.task.BlancoSedBatchProcess -verbose=値1 -input=値2 -output=値3 -script=値4 -scriptfile=値5 -encoding=値6");
        System.out.println("    -verbose");
        System.out.println("      説明[verboseモードで動作させるかどうか。]");
        System.out.println("      型[真偽]");
        System.out.println("      デフォルト値[false]");
        System.out.println("    -input");
        System.out.println("      説明[入力ファイルを指定します。]");
        System.out.println("      型[文字列]");
        System.out.println("      必須パラメータ");
        System.out.println("    -output");
        System.out.println("      説明[出力ファイルを指定します。]");
        System.out.println("      型[文字列]");
        System.out.println("      必須パラメータ");
        System.out.println("    -script");
        System.out.println("      説明[スクリプトを指定します。]");
        System.out.println("      型[文字列]");
        System.out.println("    -scriptfile");
        System.out.println("      説明[スクリプトファイルを指定します。]");
        System.out.println("      型[文字列]");
        System.out.println("    -encoding");
        System.out.println("      説明[ファイルのエンコードを指定します。]");
        System.out.println("      型[文字列]");
        System.out.println("      デフォルト値[Windows-31J]");
        System.out.println("    -? , -help");
        System.out.println("      説明[使い方を表示します。]");
    }

    /**
     * このバッチ処理クラスの入力パラメータの妥当性チェックを実施するためのメソッドです。
     *
     * @param input バッチ処理の入力パラメータ。
     * @throws IllegalArgumentException 入力値に不正が見つかった場合。
     */
    public void validateInput(final BlancoSedProcessInput input) throws IllegalArgumentException {
        if (input == null) {
            throw new IllegalArgumentException("BlancoBatchProcessBatchProcess: 処理開始失敗。入力パラメータ[input]にnullが与えられました。");
        }
        if (input.getInput() == null) {
            throw new IllegalArgumentException("BlancoSedBatchProcess: 処理開始失敗。入力パラメータ[input]の必須フィールド値[input]に値が設定されていません。");
        }
        if (input.getOutput() == null) {
            throw new IllegalArgumentException("BlancoSedBatchProcess: 処理開始失敗。入力パラメータ[input]の必須フィールド値[output]に値が設定されていません。");
        }
    }
}
